package betterwithmods.module.hardcore.needs;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWMItems;
import betterwithmods.module.Feature;
import betterwithmods.util.player.PlayerHelper;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.event.world.BlockEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.Event;
import net.minecraftforge.fml.common.eventhandler.EventPriority;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by tyler on 4/20/17.
 */
public class HCPiles extends Feature {

    public static Map<IBlockState, ItemStack> blockStateToPile = new HashMap<>();

    public static void registerPile(Block block, int meta, ItemStack stack) {
        registerPile(block.func_176203_a(meta), stack);
    }

    public static void registerPile(Block block, ItemStack stack) {
        for (IBlockState state : block.func_176194_O().func_177619_a())
            registerPile(state, stack);
        //registerPile(block.getDefaultState(), stack);
    }

    public static void registerPile(IBlockState block, ItemStack stack) {
        blockStateToPile.put(block, stack);
    }

    @Override
    public boolean requiresMinecraftRestartToEnable() {
        return true;
    }

    @Override
    public void init(FMLInitializationEvent event) {
        registerPile(Blocks.field_150346_d, new ItemStack(BWMItems.DIRT_PILE, 3));
        registerPile(Blocks.field_150346_d, 1, new ItemStack(BWMItems.DIRT_PILE, 3));
        registerPile(Blocks.field_150346_d, 2, new ItemStack(BWMItems.DIRT_PILE, 3));
        registerPile(Blocks.field_150458_ak, new ItemStack(BWMItems.DIRT_PILE, 3));
        registerPile(BWMBlocks.FERTILE_FARMLAND, new ItemStack(BWMItems.DIRT_PILE, 3));
        registerPile(Blocks.field_150349_c, new ItemStack(BWMItems.DIRT_PILE, 3));
        registerPile(Blocks.field_150391_bh, new ItemStack(BWMItems.DIRT_PILE, 3));
        registerPile(Blocks.field_185774_da, new ItemStack(BWMItems.DIRT_PILE, 3));
        registerPile(Blocks.field_150351_n, new ItemStack(BWMItems.GRAVEL_PILE, 3));
        registerPile(Blocks.field_150354_m, new ItemStack(BWMItems.SAND_PILE, 3));
        registerPile(Blocks.field_150354_m,1, new ItemStack(BWMItems.RED_SAND_PILE, 3));
        registerPile(BWMBlocks.DIRT_SLAB, new ItemStack(BWMItems.DIRT_PILE, 1));
        registerPile(Blocks.field_150435_aG, new ItemStack(Items.field_151119_aD,3));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(BWMItems.DIRT_PILE, 4), new ItemStack(Blocks.DIRT));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(Blocks.DIRT), new ItemStack(BWMItems.DIRT_PILE), new ItemStack(BWMItems.DIRT_PILE), new ItemStack(BWMItems.DIRT_PILE), new ItemStack(BWMItems.DIRT_PILE));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(BWMItems.DIRT_PILE, 2), new ItemStack(BWMBlocks.DIRT_SLAB));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(BWMBlocks.DIRT_SLAB), new ItemStack(BWMItems.DIRT_PILE), new ItemStack(BWMItems.DIRT_PILE));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(Blocks.DIRT), new ItemStack(BWMBlocks.DIRT_SLAB), new ItemStack(BWMBlocks.DIRT_SLAB));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(BWMItems.GRAVEL_PILE, 4), new ItemStack(Blocks.GRAVEL));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(Blocks.GRAVEL), new ItemStack(BWMItems.GRAVEL_PILE), new ItemStack(BWMItems.GRAVEL_PILE), new ItemStack(BWMItems.GRAVEL_PILE), new ItemStack(BWMItems.GRAVEL_PILE));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(BWMItems.SAND_PILE, 4), new ItemStack(Blocks.SAND));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(Blocks.SAND), new ItemStack(BWMItems.SAND_PILE), new ItemStack(BWMItems.SAND_PILE), new ItemStack(BWMItems.SAND_PILE), new ItemStack(BWMItems.SAND_PILE));
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(Blocks.SAND, 1, 1), new ItemStack(BWMItems.RED_SAND_PILE), new ItemStack(BWMItems.RED_SAND_PILE), new ItemStack(BWMItems.RED_SAND_PILE), new ItemStack(BWMItems.RED_SAND_PILE));
//        BWMRecipes.addOreRecipe(new ItemStack(BWMBlocks.DIRT_SLAB, 4), "##", '#', Blocks.DIRT);
    }

    @Override
    public void disabledInit(FMLInitializationEvent event) {
//        BWMRecipes.addShapelessOreRecipe(new ItemStack(Blocks.DIRT), new ItemStack(BWMBlocks.DIRT_SLAB), new ItemStack(BWMBlocks.DIRT_SLAB));
//        BWMRecipes.addOreRecipe(new ItemStack(BWMBlocks.DIRT_SLAB, 4), "##", '#', Blocks.DIRT);
    }

    @SubscribeEvent(priority = EventPriority.LOWEST)
    public void onHarvest(BlockEvent.HarvestDropsEvent event) {
        if (event.isSilkTouching() || event.getResult().equals(Event.Result.DENY))
            return;
        IBlockState state = event.getState();
        EntityPlayer player = event.getHarvester();
        if (player != null) {
            ItemStack stack = event.getHarvester().func_184614_ca();
            if (PlayerHelper.isCurrentToolEffectiveOnBlock(stack, event.getState()))
                return;
        }
        if (blockStateToPile.containsKey(state)) {
            ItemStack pile = blockStateToPile.get(state).func_77946_l();
            event.getDrops().clear();
            if (event.getWorld().field_73012_v.nextFloat() <= event.getDropChance()) {
                event.getDrops().add(pile);
            }
        }
    }

    @Override
    public String getFeatureDescription() {
        return "Makes soils drop 75% of their content if not broken with a shovel to incentivize the use of shovels";
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }
}
